/*
 * FILE     : McCreght1.h
 * Copyright (C) 2007 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : q[vT McCreght (Place Holderŋp)
 * AUTHER   : N.Tsuchiya  2007.11.25
 */
/*
	q[vT(balanced priority search trees)
	l̕tT؁Al̃q[v
	E.M.McCreight. Priority search trees. SIAM Journal on Computing, 14(2):257.276, May 1985.
 */
#if ! defined(MCCREIGHT1_H)
#define MCCREIGHT1_H

#include "ssc_c.h"
//#include "sscvect.h"

#define Empty  0

struct PSTree {  //class

 struct ExtractedPair {
	int 	qq;  //q ƃRpCG[ɂȂ̂
	char	duplAsP;
 } ;
  struct BPSTpair {
	int		n;           //ߓ_ԍ([Uw)
	int		x;           //T؂\
	int		y;           //q[v\
	int		emptyNext;   //󃊃NB擪topEmptyPairB-1:gp
//	bool operator==(const BPSTpair &p) { return n == p.n && x == p.x && y == p.y; }
////	bool operator==(const BPSTpair &p) { return n == p.n ; }
//	BPSTpair():n(-1),x(0),y(0),emptyNext(-1){}                 //ftHgRXgN^
//	BPSTpair(const BPSTpair &X):n(X.n),x(X.x),y(X.y),emptyNext(X.emptyNext){} //Rs[RXgN^
//	BPSTpair(int pn,int px,int py):n(pn),x(px),y(py),emptyNext(0){}  //RXgN^
//	BPSTpair& operator=(const BPSTpair &p) { n = p.n; x = p.x; y = p.y; return *this; }
  } ;
  struct BPSTnode {
	int 	p;       //q[v\B(leaf node)(McCreght validP=.F.)̏ꍇ     pair[]
	int 	q;       //T؂\                                     pair[]
	int 	validP;  //(McCreght only) T:t.p͗L(łȂ)
	char	duplQ;   //(McCreght only) T:t.q͑c悁a.pɐݒς F:t.qƓyA͏ʂ̂ɂ݂͑Ȃ
	int		oya;     // -2:폜   node[]
	int		left;    // -2:폜   node[]
	int		right;   //           node[]
    int    balance;           //(gp) oXx L: ɌXĂB R: EɌXĂBE: EB
    int    hight;             // ؂̍B[̍PDmFpA߂
//	BPSTnode():p(Empty),q(Empty),left(Empty),right(Empty),oya(Empty),validP(0),duplQ(false),hight(0){}  //RXgN^
//	BPSTnode(const BPSTnode &X):p(X.p),q(X.q),left(X.left),right(X.right),oya(X.oya),validP(X.validP),duplQ(X.duplQ),hight(X.hight){}  //RXgN^
//	BPSTnode& operator=(const BPSTnode &pp) { p = pp.p; q = pp.q; validP = pp.validP; duplQ = pp.duplQ;
//		oya = pp.oya; left = pp.left; right = pp.right; hight = pp.hight; return *this; }
  } ;
  struct BPSTnode *node;
  struct BPSTpair *pair;
//	sscvect<BPSTnode> node;  //node[0]͎gȂ
//	sscvect<BPSTpair> pair;  //pair[0]͎gȂ
	int		heapType;        //0:傫D 1:D add NT110404
	int		root;            //                                        node[]
	int		num_node;        //gpvfB_~[Ƌ󂫗vf܂
	int		num_pair;        //gpyAB_~[Ƌ󂫗vf܂
	int		n_node;          //폜ς݂gp node[]
	int		n_pair;          //폜ς݂gp pair[]B
	int		max_node;        //mۍςݗeʁBvf
	int		max_pair;        //mۍςݗeʁByA
	int		topEmptyNode;    //                                        node[]
	int		topEmptyPair;    //                                        pair[]
	//first() next()Tp
//	int		last_node;    //ŌɕԂm[hԍB-1:TI            node[]or-1
//	int		lastIsP;      //(McCreght only) 
//	int x1, x2, y0;
//	int 	*list1;
//	int		n_list1;
//	~PSTree(){}
//	PSTree(){n_node = n_pair = 0;  //RXgN^
//		heapType = root = topEmptyNode = topEmptyPair = Empty;
//		node.push_back(BPSTnode()); pair.push_back(BPSTpair()); }
//	PSTree(const PSTree &X):
//		heapType(X.heapType), root(X.root), n_node(X.n_node), n_pair(X.n_pair),  //Rs[RXgN^
//		topEmptyNode(X.topEmptyNode), topEmptyPair(X.topEmptyPair),
//		node(X.node), pair(X.pair) {}
//	void dump_node(int s, int e);
//	int insert(int pn,int px,int py){int hi; return insert(Empty, 0, PSTree_pair_add(struct PSTree *ps, struct BPSTpair(int pn, int px, int py)),true, &hi);}
//	int deletion(int pn,int px,int py){int hi; return deletion(&root, struct BPSTpair(int pn, int px, int py), &hi, 0);}
//	int firstAns(int *inf, int x1, int x2, int y0); //R̍ŏ̓Ԃ
//	int nextAns(int *inf);              //R̎̓Ԃ
//	int first(int x1, int x2, int y0);  //p~\iϐɋL邽߁j
//	int next();                         //p~\iϐɋL邽߁j
//	int clear(int heapType);           // add heapType NT110404
//	int compHeap(int p, int q);
//	{  //ۓTL[̔rB:(p)D :E(q)D
//		if( heapType == 0 ) return q - p;  //傫D add heapType NT110404
//		else                return p - q;  //D
//	}
//	int size();// { return n_pair; }
//	int	getHheapType(){return heapType;}  //0:傫D 1:D add NT110404
//	int getNumOfNode() {return pst->n_node;}
//	int getNumOfData() {return pst->n_pair;}
//u	int firstPair(int *inf) {*inf = 0; return nextPair(inf);} //LȑSpair擾
//u	int nextPair(int *inf) {
//		if( *inf >= 0 ) { //pair[0]͖gpB
//			while(  ++(*inf) < this->pair.size() ) {
//				if( this->pair[*inf].emptyNext < 0 ) break; //gpȂ
//			}
//		}
//		if( *inf >= this->pair.size() ) *inf = -1;
//		return (0 < *inf) ? this->pair[*inf].n : -1;
//	}
//u	int build();
//u	int build_sorted(int nList, int *list);
//	int build_sub(sscvect<int> &list, int s, int e);
//	int getQList(int *L1, int anode);
//u	int mearge(PSTree &T1, PSTree &T2, PSTree *T3);
//	int compX( struct BPSTpair *p, struct BPSTpair *q );
//	int compIdx(const int *p,const int *q ){ return compX( struct BPSTpair &pair[*p], struct BPSTpair &pair[*q] );}
	//`FbNp
//	void check0();
//private:
//	int clear1();           // pair[]ȊONA
//	int isLeaf( int anode );   //(Place holder only)
//	int disposeP( int anode );
//	int extractP( int anode );
//	int rotateRight(int *anode, int *phi );
//	int rotateLeft (int *anode, int *phi );
//	int adjustBalance(int *anode, int *phi);
//	int insert(int oya, int lrflg, int np,bool useAsP, int *phi);
//	int extractMaxQX(int *anode, struct ExtractedPair *ep, int *pd );      // McCreght1Őp
//	int deletion( int *anode, struct BPSTpair &op, int *phi, int qnode ); //qnode (Place holder only)
//	int pair_add(struct BPSTpair &wkPair);
//	int pair_del( int d );
//	int node_add(struct BPSTnode &wkNode);
//	int node_del( int d );
//	int compX( BPSTpair *p, BPSTpair *q );
//	int judgeBalance(int anode);
//	int findBelow( int rt );
//	int build_sub(int *list, int s, int e);
//	int build_sorted(int nList, int *list);
	//`FbNp
//	int check1(int oya, int v, struct BPSTpair &low, struct BPSTpair &upp);
//	int check2_1( int v);
//	int check2_2( int v);
//	sscvect<int> list1;  //
} ;


int PSTree_check1(struct PSTree *ps, int oya, int v, struct BPSTpair *low, struct BPSTpair *upp);
int PSTree_check2_1(struct PSTree *ps, int v);
int PSTree_check2_2(struct PSTree *ps, int v);
void PSTree_dump_node(struct PSTree *ps, int s, int e);
int PSTree_deletion( struct PSTree *ps, int *anode, struct BPSTpair *op, int *phi, int dmy);
int PSTree_extractMaxQX( struct PSTree *ps, int *anode, struct ExtractedPair *ep, int *pd );
int PSTree_insert( struct PSTree *ps, int oya, int lrflg, int np, char useAsP, int *phi);
int PSTree_adjustBalance( struct PSTree *ps, int *anode,  int *phi);
int PSTree_rotateLeft( struct PSTree *ps, int *anode, int *phi );
int PSTree_rotateRight(struct PSTree *ps, int *anode, int *phi );
int PSTree_extractP( struct PSTree *ps, int anode );
int PSTree_disposeP( struct PSTree *ps, int anode );
int PSTree_clear( struct PSTree *ps, int pHeapType);
int PSTree_judgeBalance(struct PSTree *ps, int anode);
int PSTree_firstAns(struct PSTree *ps, int *inf, int x1, int x2, int y0); //R̍ŏ̓Ԃ
int PSTree_nextAns(struct PSTree *ps, int *inf, int x1, int x2, int y0);              //R̎̓Ԃ
//int PSTree_first( struct PSTree *ps, int px1, int px2, int py0);
//int PSTree_next(struct PSTree *ps);
int PSTree_findBelow(struct PSTree *ps, int anode, int px1, int px2, int py0 );
int PSTree_node_del( struct PSTree *ps, int d );
int PSTree_node_add( struct PSTree *ps, struct BPSTnode *wkNode );
int PSTree_pair_del( struct PSTree *ps, int d );
int PSTree_pair_add(struct PSTree *ps, struct BPSTpair *wkPair);
int PSTree_compX(struct BPSTpair *p, struct BPSTpair *q );
int PSTree_compHeap(struct PSTree *ps, int p, int q);  //ۓTL[̔rB:(p)D :E(q)D
void PSTree_check0(struct PSTree *ps);
int PSTree_disposeP( struct PSTree *ps, int anode );
int PSTree_insertP(struct PSTree *ps, int pn,int px,int py);
int PSTree_deletionP(struct PSTree *ps, int pn,int px,int py);
void PSTree_dump_pair(struct PSTree *ps);
int PSTree_free( struct PSTree *ps );
int PSTree_init( struct PSTree *ps );
#endif //! defined(MCCREIGHT1_H)
