/*
 * FILE     : pstree2_cc.cpp
 * Copyright (C) 2007 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : q[vT(place holder)
 * AUTHER   : N.Tsuchiya  2010.04.28
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */
#define EXTERN
#include <time.h>

#include "McCreight2.h" // McCreght (Place Holderŋp)
#include "pstree2_cc.h"

PSTree pst;

/*	ID_ccBgn	
***************************************************************************/
static int ccBgn( char *funcname )
{
	int		rc = 0;
	static int iniFlg = 0;

	//err_msg[0] = '\0';
	if( iniFlg == 0 ) {
		iniFlg = 1;
		Dopen("sscDebugLog2.txt"); // 091127
		sscdbgin("sscdbg.flg");
	}
	return rc;
}
/*	ID_ccEnd	
***************************************************************************/
static int ccEnd( char *funcname )
{
	int		rc = 0;

	return rc;
}
/*	ID_cc_init	
***************************************************************************/
int cc_init()
{
	int		rc = 0;
	//int ymd;
	//struct tm *tm1;
	//time_t ltime;

	ccBgn( "cc_init" );
	if(dbgf[50])TRACEA(0),Dprintf("cc_init() \n");
	////t`FbN 20161231 ȍ~Ȃ 9Ԃ 2013.09.19 YS
	//time( &ltime );
    //tm1 = gmtime( &ltime );
	//ymd = (tm1->tm_year +1900)*10000 + (tm1->tm_mon+1)*100 + tm1->tm_mday;
	//if( ymd > 20161231 ) rc = 9; del 2019/11/26 N.Tsuchiya

	ccEnd( "cc_init" );
	if(dbgf[51])TRACEC(0),Dprintf("cc_init() rc(%d) \n", rc);
	return rc;
}
/*	ID_cc_fin	
***************************************************************************/
int cc_fin()
{
	int		rc = 0;
	ccBgn( "cc_fin" );
	if(dbgf[50])TRACEA(0),Dprintf("cc_fin() \n");

//quit:
	ccEnd( "cc_fin" );
	if(dbgf[51])TRACEC(0),Dprintf("cc_fin() rc(%d) \n", rc);
	return rc;
}
/*	ID_cc_clear	
***************************************************************************/
int cc_clear()
{
	int		rc = 0;
	ccBgn( "cc_clear" );
	if(dbgf[50])TRACEA(0),Dprintf("cc_clear() \n");

	rc = pst.clear();
//quit:
	ccEnd( "cc_clear" );
	if(dbgf[51])TRACEC(0),Dprintf("cc_clear() rc(%d) \n", rc);
	return rc;
}

/*	ID_cc_insert	
***************************************************************************/
int cc_insert(      // >=0: <0:G[
	int pn,         //i ߓ_ԍBCӂ̒l
	int px,         //i wW̒l
	int py)         //i xW̒l
{
	int		rc = 0;

	ccBgn( "cc_insert" );
	if(dbgf[50])TRACEA(0),Dprintf("cc_insert() pn, px, py , !%d!%d!%d\n", pn, px, py);

//	if( pst.n_node < 210 )
		rc = pst.insert( pn, px, py);
//quit:
	ccEnd( "cc_insert" );
	if(dbgf[51])TRACEC(0),Dprintf("cc_insert() rc(%d) \n", rc);
	if(dbgf[51]>1)pst.dump_node( -1, -1);
	return(rc);
}

/*	ID_cc_deletion	
***************************************************************************/
int cc_deletion(    // 0:o^ 1:폜
	int pn,         //i ߓ_ԍBCӂ̒l
	int px,         //i wW̒l
	int py)         //i xW̒l
{
	int		rc = 0;

	ccBgn( "cc_deletion" );
	if(dbgf[50])TRACEA(0),Dprintf("cc_deletion() pn, px, py , !%d!%d!%d\n", pn, px, py);

	rc = pst.deletion( pn, px, py);
//quit:
	ccEnd( "cc_deletion" );
	if(dbgf[51])TRACEC(0),Dprintf("cc_deletion() rc(%d) \n", rc);
	return(rc);
}
/*	ID_cc_first	x1xx2yy0łŏ̃m[h̐ߓ_ԍ([Uw)Ԃ
***************************************************************************/
int cc_first(       //ߓ_ԍ([Uw)B-1:Yߓ_
	int x1,
	int x2,
	int y0 )
{
	int		rc = 0;

	ccBgn( "cc_first" );
	if(dbgf[50])TRACEA(0),Dprintf("cc_first() x1, x2, y0 , !%d!%d!%d\n", x1, x2, y0);

	rc = pst.first( x1, x2, y0);
//quit:
	ccEnd( "cc_first" );
	if(dbgf[51])TRACEC(0),Dprintf("cc_first() rc(%d) \n", rc);
	return(rc);
}
/*	ID_cc_next	x1xx2yy0ł鎟̃m[h̐ߓ_ԍ([Uw)Ԃ
***************************************************************************/
int cc_next()       //ߓ_ԍ([Uw)B-1:Yߓ_
{
	int		rc = 0;

	ccBgn( "cc_next" );
	if(dbgf[50])TRACEA(0),Dprintf("cc_next()  \n");

	rc = pst.next();
//quit:
	ccEnd( "cc_next" );
	if(dbgf[51])TRACEC(0),Dprintf("cc_next() rc(%d) \n", rc);
	return(rc);
}

sscvect<int> nodeList;         //                  listPos[] node[]or-1
sscvect<int> listPos;          //                  nodeList[]

/*	ID_cc_getNodeNum	(tree`p)ߓ_Ԃ
***************************************************************************/
int cc_getNodeNum(             //ret 0:
	int *num)                  //o ߓ_B
{
	int		rc = 0, anode;

	ccBgn( "cc_getNodeNum" );
	if(dbgf[50])TRACEA(0),Dprintf("cc_getNodeNum()  \n");

	*num = 0;
	nodeList.clear();
	listPos.clear();
	listPos.resize(pst.nodes.a.n);        CHKB(1, 1, pst.nodes.a.n);
	listPos[0] = -1;
	for( anode = 1; anode < pst.nodes.a.n; ++anode ) {
		if( pst.nodes.a[anode].oya < 0 ) {  //폜m[h
			listPos[anode] = -1;
		} else if( pst.nodes.a[anode].p <= 0 ) {
			listPos[anode] = -1;
		} else {
			listPos[anode] = nodeList.size();
			nodeList.push_back(anode);
		}
	}
	*num = nodeList.size();
	rc = 0;
//quit:
	ccEnd( "cc_getNodeNum" );
	if(dbgf[51])TRACEC(0),Dprintf("cc_getNodeNum() rc(%d) num(%d)\n", rc, *num);
	return(rc);
}
/*	ID_cc_getNodeInf	(tree`p)Ԗڂ̐ߓ_̏Ԃ
***************************************************************************/
int cc_getNodeInf(             //ret 0:
	int k,                     //i 0..cc_getNodeNum()ŁAߓ_̒ʔԁB
	int *pn, int *px, int *py, //o Ԗڂ̐ߓ_
	int *on, int *ox, int *oy, //o eߓ_̐ߓ_
	int *ok,                   //o êԍB-1:e
	int *edgeType,             //o eƂ̎}̃^CvB-1: 1:E 0:e
	int *koType,               //o qƂ̎}̃^CvB0:q 1:q̂ 2:Eq̂ 3:EqL
	int *vVal,                 //o ̂W
	int *hVal,                 //o ̂W
	int *lLim,                 //o ̍[̂W
	int *rLim)                 //o ̉E[̂W
{
	int		rc = 0, pNode, oNode, anode, oynod;
	PSTree::BPSTpair *pnPairP, *oyPairP;

	ccBgn( "cc_getNodeInf" );
	if(dbgf[50])TRACEA(0),Dprintf("cc_getNodeInf() k!%d\n", k);
	                                    CHKA(0, k, nodeList.size());
	*pn = *px = *py = *on = *ox = *oy = *ok = *edgeType = *koType = *vVal = *hVal = *lLim = *rLim = 0;
	if( k < 0 || k >= nodeList.size() ) goto                            quit;
	pNode = nodeList[k];                  CHKA(1, pNode, pst.nodes.a.size());
	oNode = pst.nodes.a[pNode].oya;            CHKA(0, oNode, pst.nodes.a.size());
	pnPairP = &pst.pairs.a[pst.nodes.a[pNode].p];
	oyPairP = &pst.pairs.a[pst.nodes.a[oNode].p];
	*pn = pnPairP->n;
	*px = pnPairP->x;
	*py = pnPairP->y;
	*on = oyPairP->n;
	*ox = oyPairP->x;
	*oy = oyPairP->y;
	*ok = listPos[oNode];
	if       ( pNode == pst.nodes.a[oNode].right ) { *edgeType = 1;
	} else if( pNode == pst.nodes.a[oNode].left  ) { *edgeType = -1;
	} else {          CHKB(0, oNode, 0);          *edgeType = 0;
	}
	if( pst.nodes.a[pst.nodes.a[pNode].left ].p > 0 ) *koType += 1;
	if( pst.nodes.a[pst.nodes.a[pNode].right].p > 0 ) *koType += 2;
	*hVal = pnPairP->y;
	*vVal = pst.pairs.a[pst.nodes.a[pNode].q].x;
	//
	if( *edgeType > 0 ) {               CHKB(1, 1, oNode);
		*lLim = pst.pairs.a[pst.nodes.a[oNode].q].x;
		oynod = 0;
		for( anode = oNode; anode > 0; anode = pst.nodes.a[anode].oya ) {
			oynod = pst.nodes.a[anode].oya;
			if( anode == pst.nodes.a[oynod].left ) break;
		}
		if( oynod > 0 ) {
			*rLim = pst.pairs.a[pst.nodes.a[oynod].q].x;
		} else {
			*rLim =  999999999;                 //o ̉E[̍W
		}
	} else if( *edgeType < 0 ) {        CHKB(1, 1, oNode);
		*rLim = pst.pairs.a[pst.nodes.a[oNode].q].x;
		oynod = 0;
		for( anode = oNode; anode > 0; anode = pst.nodes.a[anode].oya ) {
			oynod = pst.nodes.a[anode].oya;
			if( anode == pst.nodes.a[oynod].right ) break;
		}
		if( oynod > 0 ) {
			*lLim = pst.pairs.a[pst.nodes.a[oynod].q].x;
		} else {
			*lLim = -999999999;                 //o ̉E[̍W
		}
	} else {
		*lLim = -999999999;                 //o ̍[̍W
		*rLim =  999999999;                 //o ̉E[̍W
	}
	rc = 0;
quit:
	ccEnd( "cc_getNodeInf" );
	if(dbgf[51])TRACEC(0),Dprintf("cc_getNodeInf() rc(%d) pn(%2d) px(%2d) py(%2d) on(%2d) ox(%2d) oy(%2d) ok(%2d) edgeType(%2d) koType(%d) vVal(%2d) hVal(%2d) lLim(%2d) rLim(%2d)\n"
		, rc, *pn, *px, *py, *on, *ox, *oy, *ok, *edgeType, *koType, *vVal, *hVal, *lLim, *rLim);
	return(rc);
}
/*	ID_cc_read	t@Cm[hWlǂݍ  KS110329ADD
***************************************************************************/
int cc_read(         //rc=0:, <0:t@CI[vG[
	char* fname)       //i t@C(ʎw)
{
	int		rc = -1, x, y, n = 1;
	FILE	*fpr = 0;
	char	buf[256];

	cc_clear();
	ccBgn( "cc_read" );
	if(dbgf[50])TRACEA(0),Dprintf("cc_read() fname !%s\n", fname);

	if( (fpr = fopen(fname, "r")) == 0 ) goto                  errOpn;
	while(fgets(buf, 255, fpr) != NULL){
		sscanf(buf, "%d,%d", &x , &y);
//		if( (rc = cc_insert(n, x, y)) < 0 ) goto               quit; rerun ̂ƂɂȂ̂ł߂
//		if( pst.n_node < 210 ) {
			rc = pst.insert( n, x, y);
//		}
		++n;
	}
	rc = 0;
quit:
	ccEnd( "cc_read" );
	if( fpr != 0 ) fclose( fpr ), fpr = 0;
	if(dbgf[51]) pst.dump_node(-1, -1);
	if(dbgf[51])TRACEC(0),Dprintf("cc_read() rc(%d)\n", rc);
	return rc;
errOpn: rc = -1;
	Dprintf("drtree : cannot fopen file(%s)\n", fname); fflush(stdout);
	goto                                                                       quit;
}

/*	ID_cc_write	t@Cփm[hWlo  KS110329ADD
***************************************************************************/
int cc_write(         //rc=0:, <0:t@CI[vG[
	char* fname)       //i t@C(ʎw)
{
	int		rc = -1, i;
	FILE	*fpw = 0;

	ccBgn( "cc_write" );
	if(dbgf[50])TRACEA(0),Dprintf("cc_write() fname !%s\n", fname);
	if( (fpw = fopen(fname, "w")) == 0 ) goto                  errOpn;
//	for( i = 1; i < pst.pair.n; ++i ) {
//		fprintf(fpw, "%d,%d\n", pst.pair.v[i].x , pst.pair.v[i].y);
//	}
	for( i = 0; i < pst.nodes.a.n; ++i ) {
		PSTree::BPSTnode &t = pst.nodes.a.v[i];
		if( t.oya == -2 ) continue;
		if( t.p <= 0 ) continue;
		PSTree::BPSTpair &p = pst.pairs.a[t.p];
		fprintf(fpw, "%d,%d\n",p.x, p.y );
	}
	rc = 0;
quit:
	ccEnd( "cc_write" );
	if( fpw != 0 ) fclose( fpw ), fpw = 0;
	if(dbgf[51]) pst.dump_node(-1, -1);
	if(dbgf[51])TRACEC(0),Dprintf("cc_write() rc(%d)\n", rc);
	return rc;
errOpn: rc = -1;
	Dprintf("drtree : cannot fopen file(%s)\n", fname); fflush(stdout);
	goto                                                                       quit;
}
