/*
 * FILE      : qsortIdx.h
 * FUNCTION  : classɂz̓YXg\[g֐ev[g(o֐|C^̎gp)
 * Copyright (C) 2011 Sogen System Co., Ltd
 * AUTHER    : 2011/06/12 N.Tsuchiya
 */
/*------------------------  gp
#include <vector>
using namespace std;
class node {
	int x, y;  //_̍Wl
public:	       //compA()F{staticr֐B_̍Wlr(K{ł͂Ȃ)
	static int compA(const node &p,const node &q){ //<== staticYȂ
		int rc = p.x - q.x;
		if( rc == 0 ) rc = p.y - q.y;
		return rc;
	}
};
class tree {
	vector<node> pairs;  //\̔z
public:
	int comp1(const int *p,const int *q){ //qsortIdx()ɓn\[gpr֐(K{)
		return node::compA(pairs[*p], pairs[*q]);}
	int comp2(const int *p,const int *q){ //qsortIdx()ɓn~\[gpr֐(K{)
		return node::compA(pairs[*q], pairs[*p]);}
};
int main()
{
	tree t;
	vector<int> idxList;                       //\̔z̓YXg
	//Ń\[gf[^쐬
	for( int i = 0; i < t.pair_size(); ++i )   //\̔z̓YXgB
		idxList.push_back(i);
	qsortIdx(&idxList[0], 3, t, &tree::comp1); //\̔z̓YXg\[g
}
*/
#include <assert.h>

template <class C> 
void qsortIdx(int *ary, size_t n_ary, C &t,
	int (C::*p_comp)(const int*,const int*) )
{
    register size_t lok, hik;
    register int midkey;
    size_t lo, hi, mid, lostk[64], histk[64];
	int n_stk = 1;

	lostk[0] = 0, histk[0] = n_ary;   //
	while( n_stk-- > 0 ) {
		lo = lostk[n_stk], hi = histk[n_stk]; //ary[hi]͔͈͊O
		while( lo + 1 < hi ) {          //Qȏf[^
			mid = lo + ((hi - lo) >>1); //=(lo+hi)/2 I[ot[l
			midkey = ary[mid]; ary[mid] = ary[lo]; //̒lL[ƂBary[lo]󂯂
			for( lok = lo, hik = hi - 1; lok < hik; ) {
				for( ; lok < hik; --hik )
					if( (t.*p_comp)( &ary[hik], &midkey) < 0 ) break;
				ary[lok] = ary[hik];    //ary[hik]͋󂫁Blok=hikmȂ܂Ȃ
				for( ; lok < hik; ++lok )
					if( (t.*p_comp)( &ary[lok], &midkey) > 0 ) break;
				ary[hik] = ary[lok];    //ary[lok]͋󂫁Blok=hikmȂ܂Ȃ
			}   assert(lok == hik);     //lok == hik̂͂
			ary[lok] = midkey;          //L[󂫂ɖ߂Bary[lok]͋󂫁Blok == hik
			if( hik > mid ) {           //傫X^bNɓ
				lok = lo;
				lo  = hik + 1;          //lo:󂫂̈ʒu
			} else {
				hik = hi;
				hi = lok++;             //hi:󂫂ʒuBlok:󂫂̈ʒu
				}
			if (lok + 1 < hik) { assert(n_stk<64); //Qȏf[^
				lostk[n_stk] = lok; histk[n_stk] = hik;
				++n_stk;
			}
		}
	}
#if  _DEBUG
	for (n_stk = 1; n_stk < (int)n_ary; n_stk++) {
		if( (t.*p_comp)(&ary[n_stk-1], &ary[n_stk]) > 0) {
			printf("\[głĂȂ\n"); 
			break;
		}
	}
#endif
}
//------------------------ sample main -----------------------------
//#define QSORTIDX_TEST
#if defined QSORTIDX_TEST

#include <vector>
using namespace std;

class node {
	int x, y;  //_̍Wl
public:
	//{staticr֐(K{ł͂Ȃ)
	static int compA(const node &p,const node &q){ //<== staticYȂ
		int rc = p.x - q.x;
		if( rc == 0 ) rc = p.y - q.y;
		return rc;
	}
	node(int X,int Y) : x(X), y(Y) {}
};
class tree {
	vector<node> pairs;
public:
	int comp1(const int *p,const int *q){ //qsortIdx()ɓn\[gpr֐(K{)
		return node::compA(pairs[*p], pairs[*q]);}
	int comp2(const int *p,const int *q){ //qsortIdx()ɓn~\[gpr֐(K{)
		return node::compA(pairs[*q], pairs[*p]);}
	void clear() {pairs.clear();}
	int pair_size(){return pairs.size();}
	int add(node &N) { pairs.push_back(N); return pairs.size() - 1;}
};

int checkIdx(vector<int> &idxList)
{
	static vector<int> wkList;
	int k, idx, nsize;

	nsize = idxList.size();
	wkList.clear();
	wkList.resize(nsize, -1);
	for( k = 0; k < nsize; ++k ) {
		idx = idxList[k];
		if( idx < 0 || idx >= nsize ) {
			printf(" %d Ԗڂ̃CfNX(%d)͈͊O\n", k, idx); 
		} else if( wkList[idx] != -1 ) {
			printf(" %d Ԗڂ̃CfNX(%d)do^\n", k, idx); 
		} else {
			wkList[idx] = 1;
		}
	}
	for( k = 0; k < nsize; ++k ) {
		if( wkList[idx] == -1 ) {
			printf(" %d Ԗڂ̃CfNX(%d)ss\n", k, idx); 
		}
	}
	return 0;
}
int pl[][2] = { {1, 2}, {3, 1}, {1, 0}, {0, 1}, {0, 0}, {-1, 0}, {0, -1} };
int pp[5000][2];
int main()
{
	int i, j;
	tree t;
	int (tree::*s)(const int*,const int*) = &tree::comp1;
	s = &tree::comp1; /* qsort()p */
	//\[gf[^쐬
#if 1
	for( j = 0; j < 5000; ++j ) {
		pp[j][0] = rand() % 10000;
		pp[j][1] = rand() % 10000;
		t.add(node(pp[j][0], pp[j][1]));
	}
#else
	t.add(node(pl[0][0], pl[0][1]));
	t.add(node(pl[1][0], pl[1][1]));
	t.add(node(pl[2][0], pl[2][1]));
#endif
	//\̔z̓YXgA\[g
	vector<int> idxList;
	for( i = 0; i < t.pair_size(); ++i )
		idxList.push_back(i);
	//0,1,2,3ĂяoeXg
	qsortIdx(&idxList[0], 0, t, &tree::comp1);  //OĂяoeXg
	qsortIdx(&idxList[0], 1, t, &tree::comp1);  //OĂяoeXg
	qsortIdx(&idxList[0], 2, t, &tree::comp1);  //OĂяoeXg
	qsortIdx(&idxList[0], 3, t, &tree::comp1);  //OĂяoeXg
	//\̔z̓YXg\[g
	qsortIdx(&idxList[0], idxList.size(), t, &tree::comp1);
	//\̔z̃|C^XgỸXgɕϊ
	for(  i = 0; i < idxList.size(); ++i ) {
		int k = idxList[i];
		if( i < 10 ) printf("%d (%d, %d)\n", k, pp[k][0], pp[k][1]);
	}
	printf("\n");
	//\̔z̓YXg\[g
	qsortIdx(&idxList[0], idxList.size(), t, &tree::comp2);
	//
	for(  i = 0; i < idxList.size(); ++i ) {
		int k = idxList[i];
		if( i < 10 ) printf("%d (%d, %d)\n", k, pp[k][0], pp[k][1]);
	}
	checkIdx(idxList);
	return 0;
}
#endif //defined QSORTIDX_TEST
