/* 
 * SYSTEM   : nVXeWCu
 * FILE     : dgprintf.cpp
 * All Rights Reserved, Copyright (C) 1999-2008 Sogen System Co., Ltd
 * FUNCTION : 
 * AUTHOR   : N.Tsuchiya 1999.06.23
 */
/* PROTTYPES:
	int dbgfilename(char *fname);
	int dbgclose();
	int Dprintf( char *Fmt, ... );
 * gp@
USE_STDARG`<stdarg.h>gpB(ANSI Ki)MSVC, MSVC++, HP-UX CC, HP-UX cc -Aa
`ɂ<varargs.h>gpB(SYSTEM V ݊)MSVC, MSVC++, HP-UX cc -Aa
dbgfilename(char *fname)
    o̓t@Cfnameɐݒ܂͕ύXB
	fnameNULL܂""܂dbgfilename()Ă΂ȂƂ͕Wo͂ɏo͂
	Wo(stdout)`̂Ƃfname="dgprintf.dbg"ɏo͂
	Ȍo̓t@CfcloseāAVɃt@Cfname̐擪o͂JnB
dbgclose()
	t@C̃N[Y
Dprintf( char *Fmt, ... )
	printf()Ɠl
*/

#if ! defined(Dprintf)
/*static char *__file =(char*)__FILE__;     /* should be copied into all .c files   */
#include	<stdio.h>
#include	<string.h>

#pragma warning(disable:4996) //wb_[ɓƏoȂȂB.Net2005
#pragma warning(disable:4819) //wb_[ɓĂǂƎvB.Net2005
//#define DPRINTF_TEST

#if ! defined(DPRINTF_TEST)
#  include "dgprintf.h"
#else  //! defined(DPRINTF_TEST)

/* KvɉĉLwb_[e dgprintf.hɃRs[Ďg --------------------- */
#if ! defined DPRINTFpH
#define DPRINTFpH

#if defined(__cplusplus) || defined(__STDC__)      /*  sscp.hɈړ */
#  define	USE_STDARG     /* ANSI Ki */
#  include	<stdarg.h>    /* MSVC, MSVC++, HP-UX CC, HP-UX cc -Aa */
int Dprintf( char *lpszFormat, ... );
#else
#    include <varargs.h>       /* MSVC, MSVC++, HP-UX cc -Aa */
int Dprintf( va_list va_alist,... );  /* #ifdef  _M_ALPHA ͎̎gȂ */
#endif

#if defined(__cplusplus) || defined(__STDC__) || defined(_WIN32)
int dbgclose(void);
int dbgfilename(char *fname);
#endif
#endif //! defined DPRINTFpH
/* KvɉĂ܂ł̓e dgprintf.hɃRs[Ďg --------------------- */

#endif  //! defined(DPRINTF_TEST)

static int	fclose_every_time = 0; /* Win3.1 Win95 MSDOSł͂Pǂ */
//static char *s_dbgfn = ""; /*  */
static char s_dbgfn[4000] = ""; /*  */
static FILE	*s_dfp = NULL;
static int 	second = 0;

/* ID_dbgclose t@C̃N[Y
/********************************************************************/
int dbgclose()
{
#if defined(stdout)
	if( s_dfp && s_dfp != stdout ) { fclose( s_dfp );  }
	s_dfp = NULL; //NT080104mov
#else  /* DLLŕWostdoutgȂƂ */
	if( s_dfp  ) { fclose( s_dfp ); s_dfp = NULL; }
#endif
	return(0);
}
/* ID_dbgopen t@CI[v
/********************************************************************/
static int dbgopen()
{
#if defined(stdout)
	if( s_dbgfn[0] == '\0' ) s_dfp = stdout;
#else  /* DLLŕWostdoutgȂƂ */
	if( s_dbgfn[0] == '\0' ) strcpy(s_dbgfn, "dgprintf.dbg");
#endif
	if( second == 0 && s_dbgfn[0] != '\0' ) {
	}
	//[Uw̃t@CŃI[v
	if( s_dbgfn[0] == '\0' ) {
	} else if( second ) { s_dfp = fopen( s_dbgfn, "a" );
	} else {              s_dfp = fopen( s_dbgfn, "w" );
	}
	//I[vɎsAK̃t@CɕύXăI[v
	if( s_dfp == NULL ) {               //NT061019add
		strcpy(s_dbgfn, "dgprintf.dbg");
		if( second ) s_dfp = fopen( s_dbgfn, "a" );
		else         s_dfp = fopen( s_dbgfn, "w" );
	}
	//I[vɎsAWo͂ɕύX
#if defined(stdout)
	if( s_dbgfn[0] == '\0' ) s_dfp = stdout;
#endif
	//I[vɐAsecondtOݒ
	if( s_dfp != NULL ) second = 1;     //NT061019add if()
	return( 0 );
}
/* ID_Dopen t@CI[v(ďôݗL)
/********************************************************************/
int Dopen(        // Iɏo͐ؑւdbgfilename()gB
	char *fname)  // i ŏ̂Pڂ̂ݗLBDprintf()Ă΂ꂽB
{
	int		rc;
	dbgclose();
	if( s_dbgfn[0] == '\0' )   /* NT030227 add */
		strcpy(s_dbgfn, fname);
	if( fname == NULL ) s_dbgfn[0] = '\0';
	rc = dbgopen();
	return( rc );
}
/* ID_dbgfilename o̓t@C̐ݒBVKɃt@Co͂Jn
/********************************************************************/
int dbgfilename(char *fname)
{
	strcpy(s_dbgfn, fname);
	if( fname == NULL ) s_dbgfn[0] = '\0';
	dbgclose();
	second = 0; //NT080104add
	return(0);
}

/* ID_Dprintf t@Cւ̃vg(vprintf)
/********************************************************************/
#  if defined(USE_STDARG)
int Dprintf( char *lpszFormat, ... )
{
	int		rc;
	va_list args;
	va_start(args, lpszFormat);
#  else  /* USE_STDARG      SYSTEM V ݊o[W */
/* typedef char *va_list; <= stdio.hł̒`e nɂقȂ*/
/* #define va_dcl va_list va_alist; <= varargs.hł̒`e */
int Dprintf( va_list va_alist,... )  /* #ifdef  _M_ALPHA ͎̎gȂ */
{
	int		rc;
	char	*lpszFormat;
	va_list args;
	va_start(args);
	lpszFormat = va_arg(args, char* );
#  endif /* USE_STDARG }*/

	if( s_dfp == NULL ) dbgopen();
	if( s_dfp == NULL ) return( 0 );
	rc = vfprintf( s_dfp, lpszFormat, args ) ;
	va_end( args ) ;
	if( fclose_every_time ) dbgclose();
	else fflush(s_dfp);
	return( rc ) ;
}

#endif		/* Dprintf */
//-------------------------------------------------------------
#if defined(DPRINTF_TEST)
main()
{
	int rc;
	/* ID_Dopen t@CI[v(ďôݗL) */
	Dopen("test.txt");
	for( rc = 0; rc < 100; ++rc) Dprintf( "Dprint test d(%f) i(%d) s(%s) i(%d)\n", 3.14, 123, "dprin", 321 );
#if defined(_WIN32)
	scanf("%c", &rc );
#endif
	rc = 0;
	rc /= rc;
	return(0);
}
#endif
